menu menubar {
  Nick Colourer
  .Edit Options: cline.dialog
}
On *:LOAD:
alias -l cline.status {
  if ($group(#cline).status == on) { return Off }
  else { return On }
}

alias clineini { return $readini settings.ini cline $1 }
alias clinewini { writeini settings.ini cline $1- }
; Identifiers used for easy writing and reading of .ini files

#cline on
On *:JOIN:#: {
  if $nick == $me { .timer 1 0 .cline.colourer $chan | .cline $clineini(mec) $chan $me }
  else { .cline $clineini(rc) $chan $nick }
}

On *:VOICE:#: .cline.checknick $chan $vnick
On *:DEVOICE:#: .cline.checknick $chan $vnick
On *:OP:#: .cline.checknick $chan $opnick
On *:DEOP:#: .cline.checknick $chan $opnick

alias cline.colourer {
  set -u %i 0
  :loop
  inc %i
  if (%i > $opnick($1,0)) { goto voices }
  cline $clineini(opc) $1 $opnick($1,%i)
  goto loop
  :voices
  set %i 0
  :loop2
  inc %i
  if (%i > $vnick($1,0)) { goto rest }
  cline $clineini(vc) $1 $vnick($1,%i)
  goto loop2
  :rest
  set %i 0
  :loop3
  inc %i
  if (%i > $rnick($1,0)) { goto end }
  cline $clineini(rc) $1 $rnick($1,%i)
  goto loop3
  :end
}
alias -l cline.checknick {
  if ($2 isop $1) { .cline $clineini(opc) $1 $2 | goto end }
  elseif ($2 isvo $1) { .cline $clineini(vc) $1 $2 | goto end }
  else { .cline $clineini(rc) $1 $2 }
  :end
}
#cline end

#cline2 on
On ^*:TEXT:*:#:{
  if ($nick isop $chan) { echo -ti2 $chan < $+ $chr(3) $+ $clineini(statusc) $+ @ $+ $chr(3) $+ $nick $+ $chr(3) $+ > $1- | haltdef }
  elseif ($nick isvo $chan) { echo -ti2 $chan < $+ $chr(3) $+ $clineini(statusc) $+ + $+ $chr(3) $+ $nick $+ $chr(3) $+ > $1- | haltdef }
  else { echo -ti2 $chan < $+ $chr(3) $+ $nick $+ $chr(3) $+ > $+ $1- | haltdef }
}
#cline2 end

alias -l cline.dialog dialog -m cline cline

dialog cline {
  title "Nick Colourer Script"
  size -1 -1 200 375
  button "Save it", 1, 25 322 60 20, ok
  button "Fuck it!", 2, 115 322 60 20, cancel
  button "Reset the shit!", 100, 25 350 150 20, default
  icon 4, 50 280 88 31
  text "Nick Colourer", 3, 0 10 200 20, center
  radio "Enable", 5, 25 35 60 20, group
  radio "Disable", 6, 115 35 60 20
  combo 10, 25 90 150 100, drop
  combo 20, 25 140 150 100, drop
  combo 30, 25 190 150 100, drop
  combo 40, 25 240 150 100, drop
  combo 65, 25 290 150 100, drop
  text "Colour of Op Nicks:",11, 20 70 150 20
  text "Colour of Voice Nicks:",21, 20 120 150 20
  text "Colour of Normal Nicks:",31, 20 170 150 20
  text "Colour of Your Nick:",41, 20 220 150 20
  text "Colour for @ and +",64, 20 270 150 20
}
' Definition of the dialog and it's components

on *:DIALOG:cline:init:0: {
  cline.load.colours 10
  cline.load.colours 20
  cline.load.colours 30
  cline.load.colours 40
  cline.load.colours 65
  did -d $dname 10 1
  did -d $dname 20 1
  did -d $dname 30 1
  did -d $dname 40 1
  did -d $dname 65 1
  did -f $dname 1
  if ($cline.status == on) { did -c $dname 6 }
  else { did -c $dname 5 }
  if ($clineini(vc) == $null) { $clinewini(vc,6) }
  if ($clineini(rc) == $null) { $clinewini(rc,10) }
  if ($clineini(mec) == $null) { $clinewini(mec,3) }
  if ($clineini(statusc) == $null) { $clinewini(statusc,2) }
  did -c $dname 10 $clineini(opc)
  did -c $dname 20 $clineini(vc)
  did -c $dname 30 $clineini(rc)
  did -c $dname 40 $clineini(mec)
  did -c $dname 65 $clineini(statusc)
}
On *:DIALOG:cline:sclick:1:{
  if ($did(5).state == 1) { .enable #cline2 }
  else { .disable #cline2 }
  if ($did(5).state == 1) { .enable #cline }
  else { .disable #cline }
  $clinewini(opc,$cline.getcolour($did(10).text))
  $clinewini(vc,$cline.getcolour($did(20).text))
  $clinewini(rc,$cline.getcolour($did(30).text))
  $clinewini(mec,$cline.getcolour($did(40).text))
  $clinewini(statusc,$cline.getcolour($did(65).text))
  set %i 0
  :loop
  inc %i
  if (%i > $chan(0)) { goto end }  
  .timer 1 0 .cline.colourer $chan(%i)
  goto loop
  :end
}
alias -l cline.load.colours {
  did -r cline $1
  did -a cline $1 0) White
  did -a cline $1 1) Black
  did -a cline $1 2) Blue
  did -a cline $1 3) Green
  did -a cline $1 4) Light Red
  did -a cline $1 5) Brown
  did -a cline $1 6) Purple
  did -a cline $1 7) Orange
  did -a cline $1 8) Yellow
  did -a cline $1 9) Light Green
  did -a cline $1 10) Cyan
  did -a cline $1 11) Light Cyan
  did -a cline $1 12) Light Blue
  did -a cline $1 13) Pink
  did -a cline $1 14) Grey
  did -a cline $1 15) Light Grey
}
alias -l cline.getcolour { if ($gettok($1-,1,41) isnum)  { return $gettok($1-,1,41) } }
alias nickcolours { cline.dialog }
